#ifndef __HDDUTIL_H__
#define __HDDUTIL_H__
////////////////////////////////////////////////////////////////////////////////
//
// hddutil.h/cpp
// ---------------------------------------------------------------------------
// Programmed by Raphael Kim ( Raph.K. / rageworx@gmail.com )
// Windows based primary HDD tool
//
// 2013.11.26 : Code re-written for compatible with gcc.
//
////////////////////////////////////////////////////////////////////////////////
#include <winioctl.h>

#ifndef DFP_RECEIVE_DRIVE_DATA
    #define DFP_RECEIVE_DRIVE_DATA 0x0007c088
#endif /// of DFP_RECEIVE_DRIVE_DATA

#ifdef cplusplus__
extern "C" {
#endif /// of cplusplus__

#ifdef NO_NTDDDISK_H

typedef struct _IDEREGS
{
    UCHAR bFeaturesReg;
    UCHAR bSectorCountReg;
    UCHAR bSectorNumberReg;
    UCHAR bCylLowReg;
    UCHAR bCylHighReg;
    UCHAR bDriveHeadReg;
    UCHAR bCommandReg;
    UCHAR bReserved;
} IDEREGS, *PIDEREGS, *LPIDEREGS;

typedef struct _SENDCMDINPARAMS
{
    ULONG   cBufferSize;
    IDEREGS irDriveRegs;
    UCHAR   bDriveNumber;
    UCHAR   bReserved[3];
    ULONG   dwReserved[4];
    UCHAR   bBuffer[1];
} SENDCMDINPARAMS, *PSENDCMDINPARAMS, *LPSENDCMDINPARAMS;

typedef struct _DRIVERSTATUS
{
    UCHAR bDriverError;
    UCHAR bIDEError;
    UCHAR bReserved[2];
    ULONG dwReserved[2];
} DRIVERSTATUS, *PDRIVERSTATUS, *LPDRIVERSTATUS;

typedef struct I_SENDCMDOUTPARAMS
{
    DWORD           cBufferSize;    // Size of bBuffer in bytes
    DRIVERSTATUS    DriverStatus;   // Driver status structure.
    BYTE            bBuffer[512];   // Buffer of arbitrary length
                                    // in which to store the data read from the drive.
} uSENDCMDOUTPARAMS;

#endif /// of NO_NTDDDISK_H

typedef struct _IDSECTOR
{
    USHORT  wGenConfig;
    USHORT  wNumCyls;
    USHORT  wReserved;
    USHORT  wNumHeads;
    USHORT  wBytesPerTrack;
    USHORT  wBytesPerSector;
    USHORT  wSectorsPerTrack;
    USHORT  wVendorUnique[3];
    CHAR    sSerialNumber[20];
    USHORT  wBufferType;
    USHORT  wBufferSize;
    USHORT  wECCSize;
    CHAR    sFirmwareRev[8];
    CHAR    sModelNumber[40];
    USHORT  wMoreVendorUnique;
    USHORT  wDoubleWordIO;
    USHORT  wCapabilities;
    USHORT  wReserved1;
    USHORT  wPIOTiming;
    USHORT  wDMATiming;
    USHORT  wBS;
    USHORT  wNumCurrentCyls;
    USHORT  wNumCurrentHeads;
    USHORT  wNumCurrentSectorsPerTrack;
    ULONG   ulCurrentSectorCapacity;
    USHORT  wMultSectorStuff;
    ULONG   ulTotalAddressableSectors;
    USHORT  wSingleWordDMA;
    USHORT  wMultiWordDMA;
    BYTE    bReserved[128];
} IDSECTOR, *PIDSECTOR;

////////////////////////////////////////////////////////////////////////////////

std::string GetPrimaryHDDSerial();
std::string GetHDDVolumeSerial( const char* refpath = NULL );

#ifdef cplusplus__
}
#endif /// of cplusplus__
#endif /// of __HDDUTIL_H__
